﻿# -*- coding: utf-8 -*-
#!/usr/bin/env python

#
#Copyright (c) 2008, Leblanc Simon <contact@leblanc-simon.eu>
#
#All rights reserved.
#
#Redistribution and use in source and binary forms, with or without modification, 
#are permitted provided that the following conditions are met:
#
#    * Redistributions of source code must retain the above copyright notice, 
#      this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above copyright notice, 
#      this list of conditions and the following disclaimer in the documentation 
#      and/or other materials provided with the distribution.
#    * Neither the name of the Leblanc Simon nor the names of its contributors 
#      may be used to endorse or promote products derived from this software without
#      specific prior written permission.
#
#THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
#CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
#EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
#PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
#PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
#LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
#NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
#SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

from PyQt4 import QtCore, QtGui
from ogg2mp3 import Ogg2MP3
import glob, sys
import os.path

class Ui_MainWindow(object):
	def setupUi(self, MainWindow):
		MainWindow.setObjectName("MainWindow")
		MainWindow.resize(QtCore.QSize(QtCore.QRect(0,0,596,308).size()).expandedTo(MainWindow.minimumSizeHint()))

		self.centralwidget = QtGui.QWidget(MainWindow)
		self.centralwidget.setObjectName("centralwidget")

		self.pushButton_Add = QtGui.QPushButton(self.centralwidget)
		self.pushButton_Add.setGeometry(QtCore.QRect(490,10,91,27))
		self.pushButton_Add.setObjectName("pushButton_Add")

		self.pushButton_Del = QtGui.QPushButton(self.centralwidget)
		self.pushButton_Del.setGeometry(QtCore.QRect(490,50,91,27))
		self.pushButton_Del.setObjectName("pushButton_Del")

		self.checkBox_DelMP3 = QtGui.QCheckBox(self.centralwidget)
		self.checkBox_DelMP3.setGeometry(QtCore.QRect(10,210,400,23))
		self.checkBox_DelMP3.setObjectName("checkBox_DelMP3")

		self.buttonBox_Valid = QtGui.QDialogButtonBox(self.centralwidget)
		self.buttonBox_Valid.setGeometry(QtCore.QRect(0,250,591,32))
		self.buttonBox_Valid.setLayoutDirection(QtCore.Qt.LeftToRight)
		self.buttonBox_Valid.setAutoFillBackground(False)
		self.buttonBox_Valid.setOrientation(QtCore.Qt.Horizontal)
		self.buttonBox_Valid.setStandardButtons(QtGui.QDialogButtonBox.Cancel|QtGui.QDialogButtonBox.NoButton|QtGui.QDialogButtonBox.Ok)
		self.buttonBox_Valid.setCenterButtons(True)
		self.buttonBox_Valid.setObjectName("buttonBox_Valid")

		self.listWidget_Folder = QtGui.QListWidget(self.centralwidget)
		self.listWidget_Folder.setGeometry(QtCore.QRect(10,10,471,192))
		self.listWidget_Folder.setObjectName("listWidget_Folder")
		MainWindow.setCentralWidget(self.centralwidget)

		self.statusbar = QtGui.QStatusBar(MainWindow)
		self.statusbar.setObjectName("statusbar")
		MainWindow.setStatusBar(self.statusbar)

		self.retranslateUi(MainWindow)
		QtCore.QMetaObject.connectSlotsByName(MainWindow)
		
		self.actionUi()

	def retranslateUi(self, MainWindow):
		MainWindow.setWindowTitle(QtGui.QApplication.translate("MainWindow", "QOgg2Mp3", None, QtGui.QApplication.UnicodeUTF8))
		self.pushButton_Add.setText(QtGui.QApplication.translate("MainWindow", "&Ajouter", None, QtGui.QApplication.UnicodeUTF8))
		self.pushButton_Del.setText(QtGui.QApplication.translate("MainWindow", "&Supprimer", None, QtGui.QApplication.UnicodeUTF8))
		self.checkBox_DelMP3.setText(QtGui.QApplication.translate("MainWindow", "Supprimer les fichiers OGG Vorbis apres la conversion", None, QtGui.QApplication.UnicodeUTF8))

	def actionUi(self):
		"""
		Attibut les action aux boutons
		"""
		self.centralwidget.connect(self.pushButton_Add,QtCore.SIGNAL("clicked()"),self.addFolder)
		self.centralwidget.connect(self.pushButton_Del,QtCore.SIGNAL("clicked()"),self.delFolder)
		self.centralwidget.connect(self.buttonBox_Valid,QtCore.SIGNAL("accepted()"),self.okButton)
		self.centralwidget.connect(self.buttonBox_Valid,QtCore.SIGNAL("rejected()"),self.cancelButton)

	def addFolder(self):
		"""
		Fonction permettant d'ajouter un dossier à la liste
		"""
		dir = QtGui.QFileDialog.getExistingDirectory(self.pushButton_Add, "Selectionnez un repertoire", QtCore.QDir.homePath())
		#print dir.toAscii()
		if dir != "":
			self.listWidget_Folder.addItem(dir)

	def delFolder(self):
		"""
		Fonction permettant de supprimer un dossier de la liste
		"""
		self.listWidget_Folder.takeItem(self.listWidget_Folder.currentRow())

	def isMP3Del(self):
		"""
		Renvoie si on doit supprimer les OGG lors de la conversion
		"""
		return self.checkBox_DelMP3.isChecked()

	def okButton(self):
		"""
		On valide et on lance le traitement
		"""
		nbFolder = self.listWidget_Folder.count()
		if nbFolder > 0:
			i = 0
			ogg = Ogg2MP3()
			while i < nbFolder:
				dirname = self.listWidget_Folder.item(i).text().toAscii().data()
				print dirname
				if os.path.exists(dirname):
					print dirname + " existe"
				liste = glob.glob(dirname + "*.ogg")
				liste.sort()
				for filename in liste:
					if self.isMP3Del():
						ogg.load(filename, 1)
					else:
						ogg.load(filename, 0)
					
					print ogg.save()
				i = i + 1
		else:
			print "Il n'y a aucun element a transformer"
		
		sys.exit()

	def cancelButton(self):
		"""
		On quitte l'application
		"""
		sys.exit()

